/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010-2012 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.jonas.admin.autostart.event {

import com.adobe.cairngorm.control.CairngormEvent;

import flash.events.Event;

/**
 * A BuilderEvent is dispatched when the associated action is triggered from the view.
 */
public class BuilderEvent extends CairngormEvent {
    public static var EVENT_JONAS_VERSION:String = "get JOnAS version list";
    public static var EVENT_JONAS_FOLDERS:String = "get JOnAS Root and Base folder";
    public static var EVENT_AVAILABLE_APPLI:String = "get available appli";
    public static var EVENT_DOWNLOAD_FILE:String = "download file";
    public static var EVENT_DOWNLOAD_ZIP_FILE:String = "download jonas zip file";
    public static var EVENT_GET_OUTPUT_CONTENT:String = "getOuputTextContent";
    public static var EVENT_SAVE_STARTER_INFO_IN_FILE:String = "save starter";
    public static var EVENT_LOAD_STARTERS:String = "load starters";
    public static var EVENT_JONAS_SERVICES:String = "get jonas services";
    public static var EVENT_IS_VALID_URL:String = "is valid url";
    public static var EVENT_SET_STARTER_PATH:String = "set starters path";
    public static var EVENT_DELETE_STARTER:String = "delete a starter from disk";
    public static var EVENT_START_BUILD_PROCESS:String = "start build process";
    public static var EVENT_STOP_BUILD_PROCESS:String = "stop build process";
    public static var EVENT_SAVE_FAULT:String = "save fault";

    /**
     * Creates a new BuilderEvent.
     */
    /*public function BuilderEvent(type : String, builderVo : BuilderVO) {
     super(type);
     BuilderEvent.builderVo = builderVo;
     }*/
    public function BuilderEvent(type:String) {
        super(type);
    }

    /**
     * Overrides the clone function of the CairngormEvent class.
     * returns a new BuilderEvent
     */
    override public function clone():Event {
        //return new BuilderEvent(this.type, BuilderEvent.builderVo);
        return new BuilderEvent(this.type);
    }
}
}
