/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010-2012 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.jonas.admin.autostart.vo {

import com.adobe.cairngorm.vo.IValueObject;

import mx.collections.ArrayCollection;

import org.ow2.jonas.admin.autostart.vo.configuration.*;

/**
 * Object that represent the builder parameters.
 */
[Bindable]
public class BuilderVO implements IValueObject {
    [ArrayElementType("String")]
    public var applications:ArrayCollection = new ArrayCollection();
    public var jonasZipFile:String;
    public var jonasVersion:String;
    public var jonasType:String;
    public var jonasStarterName:String;
    [ArrayElementType("org.ow2.jonas.admin.autostart.vo.StarterVO")]
    public var starters:ArrayCollection = new ArrayCollection();
    public var parameter:String;
    public var getJonasFrom:int;
    [ArrayElementType("String")]
    public var outputText:ArrayCollection = new ArrayCollection();
    public var applyConfiguration:Boolean;
    public var useFullStarter:Boolean;
    public var includeJonasClient:Boolean;
    public var configuration:ConfigurationVO = new ConfigurationVO();

    public function BuilderVO() {
    }

    public function init(builder:Object):void {
        this.applications = builder.applications;
        this.jonasZipFile = builder.jonasZipFile;
        this.jonasVersion = builder.jonasVersion;
        this.jonasType = builder.jonasType;
        this.jonasStarterName = builder.jonasStarterName;
        this.starters = builder.starters;
        this.parameter = builder.parameter;
        this.getJonasFrom = builder.getJonasFrom;
        this.outputText = builder.outputText;
        this.applyConfiguration = builder.applyConfiguration;
        this.configuration = builder.configuration;
    }
}
}
