/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010-2012 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.jonas.admin.autostart.vo {

import com.adobe.cairngorm.vo.IValueObject;

import flash.utils.IDataInput;
import flash.utils.IDataOutput;
import flash.utils.IExternalizable;

import mx.collections.ArrayCollection;

/**
 * Object that represent the starter parameters.
 */
[Bindable]
public class StarterVO implements IValueObject {
    public var jonasStarterName:String;
    public var jonasStarterPath:String;
    public var jonasStarterDescription:String;
    public var jonasStarterCreationDate:String;
    [ArrayElementType("String")]
    public var applications:ArrayCollection = new ArrayCollection();

    public function StarterVO() {
    }

    public function init(starter:Object):void {
        this.jonasStarterName = starter.jonasStarterName;
        this.jonasStarterCreationDate = starter.jonasStarterCreationDate;
        this.jonasStarterPath = starter.jonasStarterPath;
        this.jonasStarterDescription = starter.jonasStarterDescription;
        this.applications = starter.applications;
    }
}
}
